routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/prueba',function(){
	return view('user.home');
}); 

Route::get('/usuario',function(){
	return view('user.pages.user.show');
}); 
Route::get('/centro',function(){
	return view('user.pages.production.show');
}); 

Route::get('/editarc',function(){
	return view('user.pages.production.edit');
}); 

Route::get('/fc',function(){
	return view('user.pages.finance.create');
}); 

Route::get('/fe',function(){
	return view('user.pages.finance.edit');
}); 

Route::get('/fi',function(){
	return view('user.pages.finance.index');
}); 

Route::get('/fsm',function(){
	return view('user.pages.finance.showmonth');
}); 
Route::get('/fsy',function(){
	return view('user.pages.finance.showyear');
}); 


Route::get('/tc',function(){
	return view('user.pages.technical.create');
}); 

Route::get('/te',function(){
	return view('user.pages.technical.edit');
}); 

Route::get('/ti',function(){
	return view('user.pages.technical.index');
}); 

Route::get('/ts',function(){
	return view('user.pages.technical.show');
}); 





Route::get('/',function(){
	return view('auth.login');
}); 

Auth::routes(['verify'=>true]);

Route::group(['middleware'=>['auth','user:Encargado-Administrador'],'as' => 'user.'], function(){
	Route::get('/','HomeController@user_index')->name('inicio');

	Route::resource('responsable/finance','Responsable\FinanceController');
	Route::resource('responsable/production','Responsable\ProductionController');
	Route::resource('responsable/user','Responsable\UserController');
	Route::resource('responsable/technical','Responsable\TechnicalController');
	Route::post('responsable/upload_excel','Responsable\FinanceController@upload_excel')->name('finance.upload_excel');
	Route::post('responsable/technical/{technical}','Responsable\TechnicalconditionController@store')->name('technicalcondition.store');



});


Route::group(['middleware' => ['auth','user:Administrador'], 'as' => 'admin.'], function(){
	Route::get('/home','HomeController@index')->name('home');

	//Producione
	Route::resource('production','ProductionController');
	Route::get('production/{production}/update_all','ProductionController@update_all')->name('production.update_all');
	//Finance
	Route::get('finance/{production}/show_detail','FinanceController@show_detail')->name('finance.show_detail');
	Route::post('finance/upload_excel','FinanceController@upload_excel')->name('finance.upload_excel');
	Route::resource('finance','FinanceController');


	Route::resource('technical','TechnicalController');
	Route::get('technical/{technical}/downloadPDF','TechnicalController@downloadPDF')->name('technical.downloadPDF');

	Route::resource('technicalcondition','TechnicalconditionController');
	Route::post('technical/{technical}','TechnicalconditionController@store')->name('technicalcondition.store');


	Route::resource('event','EventController');
	//Period
	Route::resource('period','PeriodController');
	//user
	Route::resource('user','UserController');
	Route::get('user/{user}/assign_role','UserController@assign_role')->name('user.assign_role');
	Route::post('user/{user}/role_assignment','UserController@role_assignment')->name('user.role_assignment');
	Route::get('user/{user}/assign_permission','UserController@assign_permission')->name('user.assign_permission');
	Route::post('user/{user}/permission_assignment','UserController@permission_assignment')->name('user.permission_assignment');
	Route::post('user/{user}/update_all','UserController@update_all')->name('user.update_all');


	Route::resource('role','RoleController'); 
	Route::resource('permission','PermissionController');
});



Route::get('/clear-cache', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:cache');
    return "Cache is cleared";
});

app/Permission.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Permission extends Model
{
    protected $fillable = [
        'name','slug','description','role_id',
    ];
    //Relaciones
    public function role()
    {
        return $this->belongsTo('App\Role');
    }
    public function users()
    {
        return $this->belongsToMany('App\User')->withTimestamps();
    }

    //Almacenamiento 

    public function store($request)
    {
        $slug = str_slug($request->name. '-');
        alert('Exito','El Permiso se ha guardado','success')->showConfirmButton();
        return self::create($request->all()+[
            'slug' => $slug,
        ]);
    }
    public function my_update($request)
    {
        $slug = str_slug($request->name. '-');
        self::update($request->all()+[
            'slug' => $slug
        ]);
        alert('Exito','Permiso actualizado','success')->showConfirmButton();
    }

    //Validaciones

    //Recuperación de información

    //Otras operaciones
}

app/Http/Controllers/PermissionController.php
<?php

namespace App\Http\Controllers;

use App\Permission;
use App\Role;
use RealRashid\SweetAlert\Facades\Alert;
use App\Http\Requests\Permission\UpdateRequest;
use App\Http\Requests\Permission\StoreRequest;
use Illuminate\Http\Request;

class PermissionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.pages.permission.index',[
            'permissions' => Permission::orderBy('id','DESC')->paginate(),
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.pages.permission.create',[
            'roles' => Role::all(),
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreRequest $request, Permission $permission)
    {
        Alert::success('Success Title', 'Success Message');
        $permission = $permission->store($request);
        return redirect()->route('admin.permission.show',$permission);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Permission  $permission
     * @return \Illuminate\Http\Response
     */
    public function show(Permission $permission)
    {
        return view('admin.pages.permission.show', [
            'permission' => $permission
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Permission  $permission
     * @return \Illuminate\Http\Response
     */
    public function edit(Permission $permission)
    {
        return view('admin.pages.permission.edit',[
            'permission' => $permission,
            'roles' => Role::all(),
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Permission  $permission
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateRequest $request, Permission $permission)
    {
        $permission->my_update($request);
        return redirect()->route('admin.permission.show',$permission);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Permission  $permission
     * @return \Illuminate\Http\Response
     */
    public function destroy(Permission $permission)
    {
        $permission->delete();
        return redirect()->route('admin.permission.index');
    }
}

resources/views/admin/pages/permission/create.blade.php
@extends('admin.layouts.app')

@section('title','crear')

@section('header')


@endsection
@section('user')
active
@endsection
@section('permission')
active
@endsection
@section('content')


	<div class="col-12">
		<div class="card card-small mb-4">
			<div class="card-header border-bottom">
				<h6 class="m-0">Agregar nuevo Permiso</h6>
			</div>
			<div class="card-body">
				<div class="row">
					<div class="col-sm-12 col-lg-6 m-auto">
						<form method="POST" action="{{ route('admin.permission.store') }}">
							 @csrf
							<div class=" ">
								<label for="name" class="col-form-label text-muted">{{ __('Nombre') }}</label>
								<div class="input-group ">
									<input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old('name') }}"  autocomplete="name" autofocus placeholder="Master Administrador"> 
									@error('name')
					                    <span class="invalid-feedback" role="alert">
					                        <strong>{{ $message }}</strong>
					                    </span>
					                @enderror
								</div>
							</div>
							<div class=" ">
								<label for="role_id" class="col-form-label text-muted">{{ __('Rol') }}</label>
								<div class="input-group ">
									<select name="role_id" class="form-control @error('role_id') is-invalid @enderror">
										<option value="" disabled="" selected="">Selecciona un rol</option>
										@foreach($roles as $role)
										<option value="{{ $role->id }}">{{ $role->name }}</option>
										@endforeach
									</select>

									@error('role_id')
					                    <span class="invalid-feedback" role="alert">
					                        <strong>{{ $message }}</strong>
					                    </span>
					                @enderror
								</div>
							</div>

							<div class="mb-3">
								<label for="description" class="col-form-label text-muted">{{ __('Descripción') }}</label>
								<div class="input-group ">
									<input id="description" type="text" class="form-control @error('description') is-invalid @enderror" name="description" value="{{ old('description') }}"  autocomplete="description" autofocus placeholder="Controla todo">
									@error('description')
					                    <span class="invalid-feedback" role="alert">
					                        <strong>{{ $message }}</strong>
					                    </span>
					                @enderror
					            </div>    
							</div>
							<div class="form-group  mb-0">				          
					            <button type="submit" class="btn btn-primary">
					                {{ __('Registrar') }}
					            </button>
					        </div>
						</form>
					</div>
				</div>
			</div>
		</div>    
	</div>
	
	

@endsection

@section('footer')


@endsection

resources/views/admin/pages/permission/edit.blade.php
@extends('admin.layouts.app')

@section('title','editar : '.$permission->name)

@section('header')


@endsection
@section('user')
active
@endsection
@section('permission')
active
@endsection

@section('content')


	<div class="col-12">
		<div class="card card-small mb-4">
			<div class="card-header border-bottom">
				<h6 class="m-0">Editar nuevo Permiso</h6>
			</div>
			<div class="card-body">
				<div class="row">
					<div class="col-sm-12 col-lg-6 m-auto">
						<form method="POST" action="{{ route('admin.permission.update',$permission )}}">
							 @csrf
							{{ method_field('PUT') }}
							<div class=" ">
								<label for="name" class="col-form-label text-muted">{{ __('Nombre') }}</label>
								<div class="input-group ">
									<input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ $permission->name }}"  autocomplete="name" autofocus placeholder="Master Administrador"> 
									@error('name')
					                    <span class="invalid-feedback" role="alert">
					                        <strong>{{ $message }}</strong>
					                    </span>
					                @enderror
								</div>
							</div>
							<div class=" ">
								<label for="role_id" class="col-form-label text-muted">{{ __('Rol') }}</label>
								<div class="input-group ">
									<select name="role_id" class="form-control @error('role_id') is-invalid @enderror">
										<option value="{{ $permission->role->id }}" selected=""> {{ $permission->role->name }} </option>
										@foreach($roles as $role)
										<option value="{{ $role->id }}">{{ $role->name }}</option>
										@endforeach
									</select>

									@error('role_id')
					                    <span class="invalid-feedback" role="alert">
					                        <strong>{{ $message }}</strong>
					                    </span>
					                @enderror
								</div>
							</div>

							<div class="mb-3">
								<label for="description" class="col-form-label text-muted">{{ __('Descripción') }}</label>
								<div class="input-group ">
									<input id="description" type="text" class="form-control @error('description') is-invalid @enderror" name="description" value="{{ $permission->description }}"  autocomplete="description" autofocus placeholder="Controla todo">
									@error('description')
					                    <span class="invalid-feedback" role="alert">
					                        <strong>{{ $message }}</strong>
					                    </span>
					                @enderror
					            </div>    
							</div>
							<div class="form-group  mb-0">				          
					            <button type="submit" class="btn btn-primary">
					                {{ __('Actualizar') }}
					            </button>
					        </div>
						</form>
					</div>
				</div>
			</div>
		</div>    
	</div>
	
	
	
	
@endsection

@section('footer')


@endsection

resources/views/admin/pages/permission/index.blade.php
@extends('admin.layouts.app')

@section('title','Permisos del Sistemas')

@section('header')


@endsection
@section('user')
active
@endsection
@section('permission')
active
@endsection
@section('content')

		<section id="main-content">
      <section class="wrapper">
        <!-- page start-->
        <div class="row mt">
          <div class="col-sm-3">
            <section class="panel">
              <div class="panel-body">
              		<a href="{{ route('admin.permission.create')}}" disable="" class="btn btn-compose text-truncate">
                  		<i class="fa fa-pencil"></i>  Agregar Permiso
                	</a>

                <ul class="nav nav-pills nav-stacked mail-nav row">
                   <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2018
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2019
                  		<span class="label label-theme pull-right inbox-notification">3</span>
                  	</a>
                  </li>
                  <li class="w-100">
                  	<a href="#"> 
                  		<i class="fa fa-user"></i> 2020
                  		<span class="label label-info pull-right inbox-notification">8</span>
                  	</a>
                  </li>
                </ul>
              </div>
            </section>
          </div>
          <div class="col-sm-9">
            <section class="panel">
              <header class="panel-heading wht-bg">
                <h4 class="gen-case">
                    Lista de Permisos
                    <form action="#" class="pull-right mail-src-position">
                      <div class="input-append">
                        <input type="text" class="form-control " placeholder="Search Mail">
                      </div>
                    </form>
                  </h4>
              </header>
              <div class="panel-body minimal">
         
                <div class="table-inbox-wrap ">
                  <table class="table table-inbox table-hover">
                    <tbody>
                    	@foreach($permissions as $permission)
	
							<td class="inbox-small-cells">
								<input type="checkbox" class="mail-checkbox">
							</td>
							<td class="view-message "><a href="{{ route('admin.permission.show', $permission) }}">{{ $permission->name }}</a></td>
							<td class="view-message "><a href="{{ route('admin.permission.show', $permission) }}">{{ $permission->slug }}</a></td>
							<td class="view-message "><a href="{{ route('admin.permission.show', $permission) }}">{{ $permission->description }}</a></td>
							<td class="view-message "><a href="{{ route('admin.permission.show', $permission) }}">{{ $permission->role->name }}</a></td>
							<td class="view-message "><a href="{{ route('admin.permission.show', $permission) }}"><i class="fa fa-user"></i> 32</a></td>
							<td class="view-message "><a href="{{ route('admin.permission.edit', $permission) }}" class="px-3"><i class="fa fa-pencil"></i></a></td>
						</tr>
						@endforeach
                    </tbody>
                  </table>
                </div>
              </div>
            </section>
          </div>
        </div>
      </section>
      <!-- /wrapper -->
    </section>


@endsection

@section('footer')


@endsection

resources/views/admin/pages/permission/show.blade.php
@extends('admin.layouts.app')

@section('title',$permission->name)

@section('header')


@endsection
@section('user')
active
@endsection
@section('permission')
active
@endsection
@section('content')
	<section id="main-content">
	<section class="wrapper site-min-height">
		<div class="col-lg-12 mt">
            <div class="row content-panel">
              <div class="panel-heading w-100">
                <div class="nav nav-tabs ">

                  <div class="col-lg-10 col-md-9 col-8  my-3" >
                    <h4 class="text-truncate"> Permiso <strong>{{ $permission->name}}</strong><h4/> 

                  </div>
                  <div class=" my-auto col-lg-2 col-md-3 col-4 ">
                  	<div class="dropdown  float-right">
          					  <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          					    ACCIONES
          					  </button>
          					  <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
          					    <a class="dropdown-item" href="{{ route('admin.permission.edit',$permission)}}">Editar</a>
          	    				<a class="dropdown-item text-danger" href="#" onclick="enviar_formulario()" >Eliminar</a>

          					  </div>
          					</div>
                  </div>
                </div>
          
              </div>

              <!-- /panel-heading -->
              <div class="panel-body w-100">

                  <div id="registrar" class="">
                    <div class="col-12">
                        

                        	<div class="col-lg-6 col-md-12  ">

                        		<h3>Datos partidoles</h3>
                        		<table class="table  ">
                        			
                    					<tr class="">
                  							<td class="" style="width:130px">
                  								Nombre del permission:
                  							</td>
                  							<td class="">
                  								{{ $permission->name}}
                  							</td>			
                    					</tr>
                    					<tr class="">
                  							<td class="" style="width:130px">
                  								Slug :
                  							</td>
                  							<td class="">
                  								{{ $permission->slug}}
                  							</td>			
                    					</tr>
                    					<tr class="">
                  							<td class="" style="width:130px">
                  								Descripción :
                  							</td>
                  							<td class="">
                  								{!! nl2br(e($permission->description)) !!}
                  							</td>			
                    					</tr>
                    					
                    					
                				
                				</table>
                			</div>
		                    <div class="col-lg-6 col-md-12  ">
	                        
	                       </div>
        				<!-- /col-lg-8 -->
                      </div>
                    <!-- /row -->
                  </div>
                  <!-- /tab-pane -->
                </div>
                <!-- /tab-content -->


            </div>
            <!-- /col-lg-12 -->
    </div>
          

  </section>


</section>





	<form method="Post" action="{{ route('admin.permission.destroy', $permission) }}" name="delete_form">
		@csrf
	    {{ method_field('DELETE') }}
		
	</form>
@endsection

@section('footer')
<script type="text/javascript">
	function enviar_formulario()
	{
		swal({
			title: "¿quiere eliminar?",
			text: "Esta acción no se puede deshacer",
			type: "warning",
			showCancelButton: true,
			confirmButtonText: "Sí, continuar",
			cancelButtonText: "No, Cancelar",
		
		}).then((result) => {
			if(result.value){
				document.delete_form.submit();
			}else{
				swal(
					'Operación cancelada',
					'Registro no eliminada',
					'error'
				)
			}
		});
	}
</script>

@endsection